//
//  HTMLExport.m
//  Evolution
//
//  Created by Ivo Näpflin.
//  Copyright (c) 2004 evolution.naepflin.com. Some rights reserved.
//

#import "HTMLExport.h"
#import "Simulation.h"
#import "Tier.h"

@implementation HTMLExport

- (IBAction)Exportieren:(id)sender
{
//Extrakt aus Armin Schneiders Programm primzahlen_source.c mit einigen Anpassungen:
	FILE *datei;
	datei = fopen ("export.html" , "w+" );  //Datei zum schreiben öffnen
	if (datei == NULL )  
	{ 
		printf ("Die Datei konnte nicht geöffnet werden!");
	}
	else
	{		
		fprintf(datei,"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\">\n<html>\n<head>\n<title>Tierpopulation aus Simulation</title>\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n<link rel=\"stylesheet\" type=\"text/css\" href=\"style.css\">\n</head>\n<body>\n");

		fprintf(datei,"<h1>Tierpopulation aus einer Simulation</h1>\n\n");

		fprintf(datei,"<h6>\nEvolution Version <b>");
		NSDictionary *info = [[NSBundle mainBundle] infoDictionary];
		fprintf(datei, [[info objectForKey:@"CFBundleVersion"] cString]); 
		fprintf(datei,"</b><br>\n");

		fprintf(datei,"Anzahl Tiere: <b>");
		fprintf(datei,"%d",[mySimulation AnzahlTiere]);
		fprintf(datei,"</b><br>\n");


		fprintf(datei,"Bereits simulierte Runden: <b>");
		fprintf(datei,"%d",[mySimulation ProzessZaehler]);
		fprintf(datei,"</b><br>\n");
		
		time_t curtime = time (NULL);
		fprintf(datei, asctime (localtime(&curtime)));

		fprintf(datei,"\n</h6>\n\n");
		
		
		fprintf(datei,"<h6>\n");
		fprintf(datei,"<table border=\"1\">\n\n");
		fprintf(datei,"<tr>\n");
		fprintf(datei,"<td>Energiestand</td>\n");
		fprintf(datei,"<td>Nahrung1Anpassung</td>\n");
		fprintf(datei,"<td>Nahrung2Anpassung</td>\n");
		fprintf(datei,"<td>Nahrung1Parameter</td>\n");
		fprintf(datei,"<td>Nahrung2Parameter</td>\n");
		fprintf(datei,"<td>Anpassung</td>\n");
		fprintf(datei,"<td>Geschlecht</td>\n");
		fprintf(datei,"<td>Alter</td>\n");
		fprintf(datei,"<td>StandortX</td>\n");
		fprintf(datei,"<td>StandortY</td>\n");
		fprintf(datei,"<td>WartenParameter</td>\n");
		fprintf(datei,"<td>FortpflanzungParameter</td>\n");
		fprintf(datei,"<td>FortpflanzungEigeneArtParameter</td>\n");
		fprintf(datei,"<td>StehenBleibenBonus</td>\n");
		fprintf(datei,"</tr>\n\n");

	//Der Durchschnitt der einzelnen Werte:
		float EnergiestandSchnitt = 0;
		float Nahrung1AnpassungSchnitt = 0;
		float Nahrung2AnpassungSchnitt = 0;
		float GeschlechtSchnitt = 0;
		float Nahrung1ParameterSchnitt = 0;
		float Nahrung2ParameterSchnitt = 0;
		float AnpassungTrifftZuSchnitt = 0;
		float AlterSchnitt = 0;
		float StandortXSchnitt = 0;
		float StandortYSchnitt = 0;
		float WartenParameterSchnitt = 0;
		float FortpflanzungParameterSchnitt = 0;
		float FortpflanzungEigeneArtParameterSchnitt = 0;
		float StehenBleibenBonusSchnitt = 0;


		int Reihe = [mySimulation AnzahlTiere];
		int ReihenZaehler = 0;

		while (Reihe > ReihenZaehler)
		{
		
			Tier *gewaehltesTier = [mySimulation TierMitID:ReihenZaehler];
			
			fprintf(datei,"<tr>\n");
			
			fprintf(datei,"<td>");
			fprintf(datei, "%d", [gewaehltesTier Energiestand]);
			EnergiestandSchnitt += [gewaehltesTier Energiestand];
			fprintf(datei,"</td>\n");

			fprintf(datei,"<td>");
			fprintf(datei, "%d", [gewaehltesTier Nahrung1Anpassung]);
			Nahrung1AnpassungSchnitt += [gewaehltesTier Nahrung1Anpassung];
			fprintf(datei,"</td>\n");

			fprintf(datei,"<td>");
			fprintf(datei, "%d", [gewaehltesTier Nahrung2Anpassung]);
			Nahrung2AnpassungSchnitt += [gewaehltesTier Nahrung2Anpassung];
			fprintf(datei,"</td>\n");

			fprintf(datei,"<td>");
			fprintf(datei, "%d", [gewaehltesTier Nahrung1Parameter]);
			Nahrung1ParameterSchnitt += [gewaehltesTier Nahrung1Parameter];
			fprintf(datei,"</td>\n");

			fprintf(datei,"<td>");
			fprintf(datei, "%d", [gewaehltesTier Nahrung2Parameter]);
			Nahrung2ParameterSchnitt += [gewaehltesTier Nahrung2Parameter];
			fprintf(datei,"</td>\n");

			fprintf(datei,"<td>");
			fprintf(datei, "%d", [gewaehltesTier AnpassungTrifftZu]);
			AnpassungTrifftZuSchnitt += [gewaehltesTier AnpassungTrifftZu];
			fprintf(datei,"</td>\n");

			fprintf(datei,"<td>");
			fprintf(datei, "%d", [gewaehltesTier Geschlecht]);
			GeschlechtSchnitt += [gewaehltesTier Geschlecht];
			fprintf(datei,"</td>\n");

			fprintf(datei,"<td>");
			fprintf(datei, "%d", [gewaehltesTier Alter]);
			AlterSchnitt += [gewaehltesTier Alter];
			fprintf(datei,"</td>\n");

			fprintf(datei,"<td>");
			fprintf(datei, "%d", [gewaehltesTier StandortX]);
			StandortXSchnitt += [gewaehltesTier StandortX];
			fprintf(datei,"</td>\n");

			fprintf(datei,"<td>");
			fprintf(datei, "%d", [gewaehltesTier StandortY]);
			StandortYSchnitt += [gewaehltesTier StandortY];
			fprintf(datei,"</td>\n");

			fprintf(datei,"<td>");
			fprintf(datei, "%d", [gewaehltesTier WartenParameter]);
			WartenParameterSchnitt += [gewaehltesTier WartenParameter];
			fprintf(datei,"</td>\n");

			fprintf(datei,"<td>");
			fprintf(datei, "%d", [gewaehltesTier FortpflanzungParameter]);
			FortpflanzungParameterSchnitt += [gewaehltesTier FortpflanzungParameter];
			fprintf(datei,"</td>\n");

			fprintf(datei,"<td>");
			fprintf(datei, "%d", [gewaehltesTier FortpflanzungEigeneArtParameter]);
			FortpflanzungEigeneArtParameterSchnitt += [gewaehltesTier FortpflanzungEigeneArtParameter];
			fprintf(datei,"</td>\n");

			fprintf(datei,"<td>");
			fprintf(datei, "%d", [gewaehltesTier StehenBleibenBonus]);
			StehenBleibenBonusSchnitt += [gewaehltesTier StehenBleibenBonus];
			fprintf(datei,"</td>\n");

			
			fprintf(datei,"</tr>\n\n");
			ReihenZaehler++;
		}
		
		EnergiestandSchnitt = EnergiestandSchnitt / Reihe;
		Nahrung1AnpassungSchnitt = Nahrung1AnpassungSchnitt / Reihe;
		Nahrung2AnpassungSchnitt = Nahrung2AnpassungSchnitt / Reihe;
		GeschlechtSchnitt = GeschlechtSchnitt / Reihe;
		Nahrung1ParameterSchnitt = Nahrung1ParameterSchnitt / Reihe;
		Nahrung2ParameterSchnitt = Nahrung2ParameterSchnitt / Reihe;
		AnpassungTrifftZuSchnitt = AnpassungTrifftZuSchnitt / Reihe;
		AlterSchnitt = AlterSchnitt / Reihe;
		StandortXSchnitt = StandortXSchnitt / Reihe;
		StandortYSchnitt = StandortYSchnitt / Reihe;
		WartenParameterSchnitt = WartenParameterSchnitt / Reihe;
		FortpflanzungParameterSchnitt = FortpflanzungParameterSchnitt / Reihe;
		FortpflanzungEigeneArtParameterSchnitt = FortpflanzungEigeneArtParameterSchnitt / Reihe;
		StehenBleibenBonusSchnitt = StehenBleibenBonusSchnitt / Reihe;
	

		fprintf(datei,"<tr>\n");
		
		fprintf(datei,"<td>");
		fprintf(datei, "%f", EnergiestandSchnitt);
		fprintf(datei,"</td>\n");

		fprintf(datei,"<td>");
		fprintf(datei, "%f", Nahrung1AnpassungSchnitt);
		fprintf(datei,"</td>\n");

		fprintf(datei,"<td>");
		fprintf(datei, "%f", Nahrung2AnpassungSchnitt);
		fprintf(datei,"</td>\n");

		fprintf(datei,"<td>");
		fprintf(datei, "%f", Nahrung1ParameterSchnitt);
		fprintf(datei,"</td>\n");

		fprintf(datei,"<td>");
		fprintf(datei, "%f", Nahrung2ParameterSchnitt);
		fprintf(datei,"</td>\n");

		fprintf(datei,"<td>");
		fprintf(datei, "%f", AnpassungTrifftZuSchnitt);
		fprintf(datei,"</td>\n");

		fprintf(datei,"<td>");
		fprintf(datei, "%f", GeschlechtSchnitt);
		fprintf(datei,"</td>\n");

		fprintf(datei,"<td>");
		fprintf(datei, "%f", AlterSchnitt);
		fprintf(datei,"</td>\n");

		fprintf(datei,"<td>");
		fprintf(datei, "%f", StandortXSchnitt);
		fprintf(datei,"</td>\n");

		fprintf(datei,"<td>");
		fprintf(datei, "%f", StandortYSchnitt);
		fprintf(datei,"</td>\n");

		fprintf(datei,"<td>");
		fprintf(datei, "%f", WartenParameterSchnitt);
		fprintf(datei,"</td>\n");

		fprintf(datei,"<td>");
		fprintf(datei, "%f", FortpflanzungParameterSchnitt);
		fprintf(datei,"</td>\n");

		fprintf(datei,"<td>");
		fprintf(datei, "%f", FortpflanzungEigeneArtParameterSchnitt);
		fprintf(datei,"</td>\n");

		fprintf(datei,"<td>");
		fprintf(datei, "%f", StehenBleibenBonusSchnitt);
		fprintf(datei,"</td>\n");

		fprintf(datei,"</tr>\n\n");
		
		fprintf(datei,"<tr>\n");
		fprintf(datei,"<td>Energiestand</td>\n");
		fprintf(datei,"<td>Nahrung1Anpassung</td>\n");
		fprintf(datei,"<td>Nahrung2Anpassung</td>\n");
		fprintf(datei,"<td>Nahrung1Parameter</td>\n");
		fprintf(datei,"<td>Nahrung2Parameter</td>\n");
		fprintf(datei,"<td>Anpassung</td>\n");
		fprintf(datei,"<td>Geschlecht</td>\n");
		fprintf(datei,"<td>Alter</td>\n");
		fprintf(datei,"<td>StandortX</td>\n");
		fprintf(datei,"<td>StandortY</td>\n");
		fprintf(datei,"<td>WartenParameter</td>\n");
		fprintf(datei,"<td>FortpflanzungParameter</td>\n");
		fprintf(datei,"<td>FortpflanzungEigeneArtParameter</td>\n");
		fprintf(datei,"<td>StehenBleibenBonus</td>\n");
		fprintf(datei,"</tr>\n\n");
		
		fprintf(datei,"</table>\n</h6><h6><a href=\"http://evolution.naepflin.com\">evolution.naepflin.com</a></h6>\n</html>\n</body>\n</html>");
	}
	
	fclose (datei);
}

@end
